''
'' single wire serial link, 4 cycles/bit
''
''        Author: Marko Lukat
'' Last modified: 2010/11/24
''       Version: 0.5
''
CON
  _clkmode = client#_clkmode
  _xinfreq = client#_xinfreq

CON
  PIN_RxD = 16                                          ' incoming data
  PIN_TxD = PIN_RxD                                     ' outgoing data

OBJ
  client: "core.con.client.demoboard"
  reader: "proplink.rx.2048"
  writer: "proplink.tx.2048"
  serial: "FullDuplexSerial"

PUB selftest | storage[3], rx, tx

  serial.start(31, 30, %0000, 115200)
  
  repeat
    serial.rxflush                                      ' discard input
    serial.rx                                           ' wait for key press
    serial.tx(0)                                        ' clear screen
     
    storage[0] := PIN_RxD
    storage[1] := 0
    storage[2] := PIN_TxD

    tx := writer.init(@storage[2])                      ' start writer
    rx := reader.init(@storage[0])                      ' start reader
     
    if rx and tx                                        ' OK
      repeat until (storage[0] + storage[1]) == -1      ' wait for result

      serial.hex(storage[0], 8)                         ' |
      serial.tx("|")                                    ' | report successful and
      serial.hex(storage[1], 8)                         ' | failed transmissions
      serial.tx(13)                                     ' |
    else                                                ' NG
      serial.str(string("Setup failed: "))              ' complain
    serial.dec(tx - 1)                                  ' |
    serial.tx("/")                                      ' |
    serial.dec(rx - 1)                                  ' |
    serial.tx(13)                                       ' | display cog pair used
     
DAT             org     0                       ' pin validation

                res     (PIN_RxD) >> 5 <# 1     ' min(n, 1)
                res     (PIN_TxD) >> 5 <# 1     ' min(n, 1)

                fit     0
               
DAT